<template>
  <div>
    <ob-filters-from-to-date-type
        @changeHeight="onChangeHeight"
        :is-loader="isLoaderClientFilter"
        @update="onUpdateFilters"
    />

    <spot-list-table
        ref="spot-list-table"
        :table-height="tableHeight"
        :columns="columns"
        :key="componentKey"
        @remove="onOpenModal"
    />

    <ob-modal
        ref="cancelSpotModal"
        :is-show-controls="true"
        :is-error="true"
        title="Отмена спота"
        size="small"
        okText="Отменить"
        cancelText="Не отменять"
        @submit="onCancelSpot"
    >
      <p>Вы уверены, что хотите отменить спот-аукцион?</p>
    </ob-modal>
  </div>
</template>

<script>
import ObFiltersFromToDateType from 'src/components/ObFiltersFromToDateType'
import SpotListTable from 'src/pages/spotPage/spotListTable'
import { mapGetters, mapMutations } from 'vuex'
import { spotInitItem } from '@/resources/spot'
import ObModal from 'common-components/src/obComponents/obModal/index'

export default {
  name: 'spotList',
  components: {
    ObFiltersFromToDateType,
    SpotListTable,
    ObModal
  },
  created () {
    this.setSpotItem({ ...spotInitItem })
  },
  beforeDestroy () {
    this.setSpotClientFilter({})
  },
  watch: {
    $route () {
      switch (this.$route.name) {
        case 'spot__list_completed':
          this.componentKey = 'spot__list_completed'
          break
        case 'spot__list_draft':
          this.componentKey = 'spot__list_draft'
          break
      }
    }
  },
  data () {
    return {
      allItems: false,
      componentKey: 0,
      isOpenFilters: true,
      locationTo: '',
      locationFrom: '',
      dateFrom: new Date(),

      columns: [
        {
          title: '',
          key: 'checkbox',
          slotName: 'checkbox'
        },
        {
          title: '№ спота',
          key: 'number',
          width: 145
        },
        {
          title: 'Маршрут',
          key: 'startAddress',
          width: '285',
          slotName: 'route'
        },
        {
          title: 'Дата погрузки',
          key: 'fromDt',
          slotName: 'fromDt'
        },
        {
          title: 'Тип ТС',
          key: 'resourceTypeTitle',
          width: 180
        },
        {
          title: 'Тип аукциона',
          key: 'auctionType',
          slotName: 'auctionType',
          width: 60
        },
        {
          title: 'Текущая ставка без НдС',
          key: 'currentPrice',
          slotName: 'currentPrice',
          width: 110
        },
        {
          title: 'Лидирующий контрагент',
          key: 'leadPartner',
          slotName: 'leadPartner',
          width: 145
        },
        {
          title: 'Статус',
          key: 'status',
          slotName: 'status',
          action: () => {}
        }
      ]
    }
  },
  computed: {
    ...mapGetters({
      isLoaderClientFilter: 'spot/isLoaderClientFilter',
      urlMap: 'spot/urlMap'
    }),
    tableHeight () {
      if (this.isOpenFilters) {
        return window.innerHeight - 630
      }
      return window.innerHeight - 355
    }
  },
  methods: {
    ...mapMutations({
      setSpotItem: 'spot/SET_SPOT_ITEM',
      setSpotClientFilter: 'spot/SET_SPOT_CLIENT_FILTER',
      setSpotClientFilterLoader: 'spot/SET_SPOT_CLIENT_FILTER_LOADER'
    }),
    onUpdateFilters (filter) {
      this.setSpotClientFilterLoader(true)
      this.setSpotClientFilter(filter)
      this.$refs['spot-list-table'].getSpotListByTab(this.urlMap[this.$route.name].tab)
    },
    onOpenModal () {
      this.$refs.cancelSpotModal.open()
    },
    onCancelSpot () {
      let notificationId = new Date().getTime() + '_remove'
      this.$notification({
        type: 'system_notification_in_load',
        message: 'Удалить',
        id: notificationId
      })
      setTimeout(() => {
        this.$notification({ event: 'close', id: notificationId })
      }, 1000)
    },
    onChangeHeight () {
      this.isOpenFilters = !this.isOpenFilters
    }
  }
}
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";

/deep/ {
  .ob-spot-list {
    &__route {
      width: 265px;
      display: flex;
      justify-content: space-between;
      font-size: 14px;

      &-dots {
        display: flex;
        justify-content: center;
        align-items: center;
        flex-grow: 12;
        position: relative;
        margin: 0 8px;
        min-width: 35px;

        &::after {
          position: absolute;
          content: '';
          top: 50%;
          width: 100%;
          height: 1px;
          border-top: 2px $color-blue-heavenly dotted;
        }

        &-count {
          background: $background-white;
          padding: 0 3px;
          height: 16px;
          font-size: 10px;
          line-height: 15px;
          letter-spacing: 1px;
          color: $color-blue-navy-blue;
          border: 1px solid $color-blue-heavenly;
          border-radius: 5px;
          z-index: 1;
        }
      }
    }

    &__icon {
      font-size: 22px;
      text-align: center;
    }

    .table-data {
      .td-container > div {
        width: 100%;
      }
    }

    .ob-func-panel .icon.-light-raspberry-red::before {
      color: $color-error !important;
    }
  }
}
</style>
